Adding update, bulding framework for multiline

This commit is contained in:
Alex Epstein 2017-07-05 12:52:58 -04:00
parent 1380d69c47
commit c813596481
1 changed files with 105 additions and 46 deletions

View File

@ -2,81 +2,140 @@
# Author: Linyos Torovoltos github.com/linyostorovovoltos
currentVersion="1.9.0"
flag=""
multiline="0"
getConfiguredClient()
{
if command -v curl &> /dev/null ; then
configuredClient="curl"
elif command -v wget &v/dev/null ; then
configuredCLient="wget"
elif command -v fetch &>/dev/null ; then
configuredClient="fetch"
else
echo "Error: This tool requires either curl, wget, or fetch to be installed." >&2
return 1
fi
if command -v curl &> /dev/null ; then
configuredClient="curl"
elif command -v wget &v/dev/null ; then
configuredClient="wget"
elif command -v fetch &>/dev/null ; then
configuredClient="fetch"
else
echo "Error: This tool requires either curl, wget, or fetch to be installed." >&2
return 1
fi
}
update()
{
# Author: Alexander Epstein https://github.com/alexanderepstein
# Update utility version 1.2.0
# To test the tool enter in the defualt values that are in the examples for each variable
repositoryName="Bash-Snippets" #Name of repostiory to be updated ex. Sandman-Lite
githubUserName="alexanderepstein" #username that hosts the repostiory ex. alexanderepstein
nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one
latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option
if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]];then
echo "Error: update utility has not been configured correctly." >&2
exit 1
elif [[ $latestVersion == "" ]];then
echo "Error: no active internet connection" >&2
exit 1
else
if [[ "$latestVersion" != "$currentVersion" ]]; then
echo "Version $latestVersion available"
echo -n "Do you wish to update $repositoryName [Y/n]: "
read -r answer
if [[ "$answer" == "Y" || "$answer" == "y" ]] ;then
cd ~ || { echo 'Update Failed' ; exit 1 ; }
if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi
git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version" ; exit 1; }
cd $repositoryName || { echo 'Update Failed' ; exit 1 ;}
git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit."
chmod a+x install.sh #this might be necessary in your case but wasnt in mine.
./$nameOfInstallFile "update" || exit 1
cd ..
rm -r -f $repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; }
else
exit 1
fi
else
echo "$repositoryName is already the latest version"
fi
fi
}
httpGet()
{
case "$configuredClient" in
curl) curl -A curl -s "$@";;
wget) wget -q0- "$@";;
fetch) fetch -o "...";;
esac
case "$configuredClient" in
curl) curl -A curl -s "$@";;
wget) wget -q0- "$@";;
fetch) fetch -o "...";;
esac
}
makeqr()
{
echo "Processing input:" $input
input=$(echo $input | sed s/" "/%20/ )
echo $input
httpGet qrenco.de/$input
{
input=$(echo $input | sed s/" "/%20/ )
httpGet qrenco.de/$input
}
makeMultiLineQr()
{
if [[ $configuredClient != "curl" ]]; then
echo "Multiline support is for now curl only!"
return 1
else
printf "%s" "$*" | curl -F-=\<- qrenco.de
fi
}
checkInternet()
{
echo -e "GET http://google.com HTTP/1.0\n\n" | nc google.com 80 > /dev/null 2>&1
if [ $? -eq 0 ]; then
return 0
else
echo "Error: no active internet connect" >&2
return 1
fi
echo -e "GET http://google.com HTTP/1.0\n\n" | nc google.com 80 > /dev/null 2>&1
if [ $? -eq 0 ]; then
return 0
else
echo "Error: no active internet connect" >&2
return 1
fi
}
usage()
{
echo "Usage: qrify [stringtoturnintoqrcode]"
echo " -u Update Bash-Snippet Tools"
echo " -h Show the help"
echo " -v Get the tool version"
echo "Usage: qrify [stringtoturnintoqrcode]"
echo " -u Update Bash-Snippet Tools"
echo " -m Enable multiline support (feature not working yet)"
echo " -h Show the help"
echo " -v Get the tool version"
}
getConfiguredClient || exit 1
checkInternet || exit 1
while getopts hv:u*: option
while getopts m:hvu*: option
do
case "${option}" in
h) usage && exit 0 ;;
*) usage && exit 0 ;;
esac
case "${option}" in
v) echo "Version $currentVersion" && exit 0 ;;
u) update && exit 0 || exit 1 ;;
h) usage && exit 0 ;;
m) multiline="1" && echo "Error this is not a supported feature yet" && exit 1 ;;
*) usage && exit 0 ;;
esac
done
if [[ $# == "0" ]]; then
usage
exit 0
usage
exit 0
elif [[ $1 == "help" ]]; then
usage
exit 0
usage
exit 0
elif [[ $1 == "update" ]];then
update || exit 1
exit 0
else
input=$(printf '%s ' "$@")
makeqr || exit 1
if [[ $multiline == "0" ]];then
input=$(printf '%s ' "$@")
makeqr || exit 1
exit 0
else
makeMultiLineQr "${@:2}" || exit 1
exit 0
fi
fi